#pragma once

#include "CoreMinimal.h"
#include "Blueprint/UserWidget.h"
#include "MobileBaseUserWidget.generated.h"

class UWidget;
class UWidgetAnimation;

UCLASS(Blueprintable, Abstract, EditInlineNew)
class DBDUIVIEWSMOBILE_API UMobileBaseUserWidget : public UUserWidget
{
	GENERATED_BODY()

protected:
	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UWidget* HighlightWidget;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _tutorialAnimationName;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	int32 _tutorialNumberOfLoops;

private:
	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	TMap<FName, UWidgetAnimation*> _animationMap;

private:
	UFUNCTION(BlueprintCallable)
	void TutorialAnimationFinished();

protected:
	UFUNCTION(BlueprintCallable)
	void TryBroadcastOnHighlightWidgetClicked();

public:
	UFUNCTION(BlueprintCallable)
	void TriggerTutorialVisuals();

	UFUNCTION(BlueprintCallable)
	void PropagateOnHighlightWidgetClicked(const FName onBoardingID);

	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void OnSynchronizeProperties();

	UFUNCTION(BlueprintCallable)
	bool IsInTutorialState();

	UFUNCTION(BlueprintCallable)
	void FinishTutorialVisuals();

public:
	UMobileBaseUserWidget();
};

FORCEINLINE uint32 GetTypeHash(const UMobileBaseUserWidget) { return 0; }
